/*
  CPP_CONTEST=2013Cal-2011
  CPP_PROBLEM=N
  CPP_LANG=C+OPENMP+MPI
  CPP_PROCESSES_PER_NODE=marte 1
*/

// 1

/*RECORD, January 30, 2012
University of La Laguna
time: 359 mssec
speedup: 45.13
*/

/*RECORD in the new system
when the programs in the record table are run in the new system
formed by marte+mercurio (two hexacores),
it is the absolute record, with
time 601
speed-up 33.28
Only one process with six threads is used,
so the high speed-up is obtained by sequential optimizations and openmp
*/

#include <stdlib.h>
#include "mpi.h"
#include "omp.h"

void mm2(int t,double *a,double *b,double *c,int init, int max)
{
  int i, j, k,value;
  double s,*p;
//omp_set_num_threads(1);
// printf("soy nodo dentro del mm2  %d  despues\n", nodo);
  for (i = init; i < max+init; i++) 
  {
//    printf("Linea i=%d\n",i);
//    jt=0;i
    p= & c[ i * t ];
omp_set_num_threads(6);
#pragma omp parallel for shared(a,b,p,i) private(j,k,s)
    for(j=0;j<t;j++)
    {
      s=0.;
 //    omp_set_num_threads(4);
     //pragma omp for reduction(+:s) private(k)
      for (k = 0; k < t; k++)
	s += a[i*t+k]*b[j*t+k];
       //printf("sa\n");
      p[j]=s;
      // c[i*t+j]=s;
//     jt+=t;
    }
//    it+=t;
  }

  

//  printf("saliendo del forr \n");


//  printf("saliendo del pragmaaa\n");

}

void sec(int t,double *a,double *b,double *c,double *d,double *r,int nodo,int np)
{
  int i, j, inicio, inicio2, iteraciones,iteraciones2;
  double *temp;
  double *bb;
  double *cc;
  double *dd;
  MPI_Status status;

//printf("soy nodo %d \n", nodo);
  MPI_Bcast(&t,1,MPI_INT,0,MPI_COMM_WORLD);
//printf("soy nodo  %d  despues t = %d \n", nodo,t);
//  t = 1000;

//printf("soy nodo  %d  antes de malloc\n", nodo);

  temp=(double *) malloc(sizeof(double)*t*t);
  bb=(double *) malloc(sizeof(double)*t*t);
  cc=(double *) malloc(sizeof(double)*t*t);
  dd=(double *) malloc(sizeof(double)*t*t);
  if ( nodo != 0 ) {
    a=(double *) malloc(sizeof(double)*t*t);
    r=(double *) malloc(sizeof(double)*t*t);

  }

//printf("soy nodo  %d  despues de malloc\n", nodo);

  iteraciones2 = (int)(t/np);
  iteraciones=iteraciones2;
  inicio2 = t % np;
  inicio = inicio2;

  if ( nodo >= inicio ) { 
     inicio= ( inicio * ( iteraciones + 1 ) ) + ( ( nodo - inicio ) * iteraciones );
  }
  else if ( nodo < inicio ) {
     iteraciones++;
     inicio= nodo*iteraciones ;
  }

  if ( nodo == 0) {

      for (i = 0; i < t; i++)  {
//    printf("i=%d\n",i);
     //     pa= & b[ i * t ];
      //    pb= & c[ i * t ];
      //    pc= & d[ i * t ];
//pragma omp parallel for shared(a,pb,pc,pd,bb,cc,dd,t,i) private(j)

       for(j=0;j<t;j++){
          bb[j*t+i]=b[i*t+j];
          cc[j*t+i]=c[i*t+j];
          dd[j*t+i]=d[i*t+j];
       }
     }

   MPI_Bcast(a,t*t,MPI_DOUBLE,0,MPI_COMM_WORLD);    
   MPI_Bcast(bb,t*t,MPI_DOUBLE,0,MPI_COMM_WORLD);
   MPI_Bcast(cc,t*t,MPI_DOUBLE,0,MPI_COMM_WORLD);
   MPI_Bcast(dd,t*t,MPI_DOUBLE,0,MPI_COMM_WORLD);

  }
  else {
  //printf("soy nodo  %d  inicio en %d y acabo en %d\n", nodo, inicio,iteraciones);
   MPI_Bcast(a,t*t,MPI_DOUBLE,0,MPI_COMM_WORLD);    
   MPI_Bcast(bb,t*t,MPI_DOUBLE,0,MPI_COMM_WORLD);
   MPI_Bcast(cc,t*t,MPI_DOUBLE,0,MPI_COMM_WORLD);
   MPI_Bcast(dd,t*t,MPI_DOUBLE,0,MPI_COMM_WORLD);

  }

//printf("soy nodo crack %d  despues\n", nodo);
  mm2(t,a,bb,temp,inicio,iteraciones);
//  printf("saliendo del mm2\n");
  


  mm2(t,temp,cc,a,inicio,iteraciones);
  mm2(t,a,dd,r,inicio,iteraciones);

//printf("soy nodo  %d  inicio en %d y acabo en %d\n", nodo, inicio,iteraciones);
  if ( nodo == 0 ) {
     int base;
     i=1;
//     printf("soy nodo  %d  yeahh %d \n", nodo, inicio2 *iteraciones );
     for ( ; i < inicio2;i++ ) {
       MPI_Recv( &r[iteraciones*i*t] ,iteraciones*t, MPI_DOUBLE, i,
          5, MPI_COMM_WORLD, &status);

//        MPI_Recev iteraciones
     }
     j=0;
     base = iteraciones*i;
     for ( ; i < np ; i++ ) {
  //      MPI_Recev iteraciones2
   //    printf("voy a recibir del nodo %d, empiezo en la iteracion i=%d  \n", i,( (iteraciones*i) + (j*iteraciones2) ) );
       MPI_Recv( & r[  ( base + (j*iteraciones2) ) *t ] ,iteraciones2 * t, MPI_DOUBLE, i,
          5, MPI_COMM_WORLD, &status);
       j++;
     }

  } else {
       MPI_Send( &r[ inicio*t ], iteraciones * t,
          MPI_DOUBLE, 0, 5,
          MPI_COMM_WORLD);


  }


  free(temp);
  free(bb);
  free(cc);
  free(dd);
}

